DCHROOT-DSA(1)

NOM
dchroot-dsa — entrer dans un environnement de chroot.

RÉSUMÉ
dchroot-dsa [-h|--help | -V|--version | -l|--list | -i|--info | --config | -p|--listpaths] [-d répertoire|--directory=répertoire] [-q|--quiet | -v|--verbose] [-c chroot|--chroot=chroot | --all | CHROOT] [COMMANDE]

DESCRIPTION
dchroot-dsa autorise l'utilisateur à exécuter une commande ou un interpréteur de commande de connexion dans un environnement chrooté. Si aucune commande n'est précisée, un interpréteur de commande de connexion sera démarré dans le répertoire personnel de l'utilisateur dans le chroot.

L'environnement de l'utilisateur sera préservé à l'intérieur du chroot.

La commande est un unique argument qui doit être un chemin absolu vers le programme. Des options supplémentaires ne sont pas permises.

Le répertoire dans lequel la commande ou l'interpréteur de commande de connexion sont exécutés dépend du contexte. Voir l'option --directory ci-dessous pour une description complète.

Cette version de dchroot-dsa est une encapsulation de compatibilité autour du programme schroot(1). Elle est fournie à des fins de rétro-compatibilité avec les options de ligne de commande de dchroot-dsa, mais schroot est recommandé pour des utilisations futures. Voyez la section “ Incompatibilités” ci-dessous pour plus d'informations sur des incompatibilités connues avec des versions plus anciennes de dchroot-dsa.

OPTIONS
dchroot-dsa accepte les options suivantes :

  Options basiques

-h, --help
    Afficher un résumé de l'aide.

-a, --all
    Sélectionner tous les chroots. Notez que les versions précédentes de dchroot-dsa n'incluent pas cette option.

-c, --chroot=chroot
    Spécifier un chroot à utiliser. Cette option peut être utilisée plusieurs fois pour spécifier plus d'un chroot, qui dans ce cas a un effet similaire à --all. Si cette option n'est pas utilisée, le premier argument non option définira le chroot à utiliser. Notez que les versions précédentes de dchroot-dsa n'incluent pas cette option.

-l, --list
    Lister tous les chroots disponibles.

-i, --info
    Afficher des informations détaillées à propos des chroots disponibles. Notez que les versions précédentes de dchroot-dsa n'incluent pas cette option.

-p, --listpaths
    Afficher les chemins absolus des chroots disponibles.

--config
    Afficher la configuration des chroots disponibles. C'est utile pour tester que la configuration utilisée est la même que celle du fichier de configuration. Tous les commentaires du fichier d'origine sont omis. Notez que les versions précédentes de dchroot-dsa n'incluent pas cette option.

-d, --directory=répertoire
    Se déplacer dans le répertoire dans le chroot avant d'exécuter la commande ou l'interpréteur de commande de connexion. Si le répertoire n'est pas disponible, dchroot-dsa se terminera par un état d'erreur.

    Le comportement par défaut (tous les répertoires sont dans le chroot) est d'exécuter l'interpréteur de commande de connexion ou la commande dans le répertoire personnel de l'utilisateur, ou dans / si le répertoire personnel n'est pas disponible. Si aucun de ces répertoires n'est disponible, dchroot se terminera par un état d'erreur.

-q, --quiet
    Afficher uniquement les messages essentiels. Notez que les versions précédentes de dchroot-dsa n'incluent pas cette option.

-v, --verbose
    Afficher tous les messages. Notez que les versions précédentes de dchroot-dsa n'incluent pas cette option.

-V, --version
    Afficher les informations de version.

CONFIGURATION

INCOMPATIBILITÉS

  Debian dchroot antérieur à la version 1.5.1

•   Cette version de dchroot-dsa utilise schroot.conf pour sauver la configuration pour les chroots disponibles, au lieu du fichier dchroot.conf utilisé historiquement. dchroot-dsa prend en charge la migration automatique de dchroot.conf vers le format de fichier par clé de schroot.conf avec l'option --config des versions 0.2.2 à 1.5.0 ; la prise en charge des formats plus anciens n'est plus disponible.

  dchroot DSA

•   Les messages d'information sont formulés et formatés différemment.

•   dchroot-dsa fournit un nombre restreint des fonctionnalités implémentées par schroot, mais c'est quand même schroot qui est au-dessous. Par conséquent dchroot-dsa est toujours soumis aux vérifications de sécurité de schroot, incluant les authentification et autorisation PAM et la gestion des sessions, par exemple, et par conséquent il peut se comporter légèrement différemment des versions plus anciennes de dchroot-dsa dans certaines circonstances.

  dchroot de Debian
Le paquet dchroot fournit une implémentation alternative de dchroot.

•   Toutes les incompatibilités ci-dessus s'appliquent.

•   Cette version de dchroot possède des options de ligne de commande incompatibles et certaines de ces options sont gérées ou ont des options équivalentes avec un nom différent, l'option -c n'est pas nécessaire pour spécifier un chroot. Elle permet également à un shell script d'être utilisé comme option au lieu d'un chemin absolu unique ce qui permet l'exécution de commandes à options multiples au lieu d'une seule option.

RÉPERTOIRES DE SUBSTITUTION

dchroot-dsa sélectionnera un répertoire approprié à utiliser à l'intérieur du chroot suivant si l'option --directory est utilisée. Quand un répertoire est explicitement spécifié, un seul répertoire sera utilisé pour des raisons de sécurité et d'intégrité, tandis que pour un interpréteur de connexion ou des commandes plusieurs possibilités peuvent être essayées. Notez qu'à cause de multiples solutions de repli considérées pour les commandes, il est dangereux d'exécuter des commandes en utilisant dchroot ; utiliser schroot à la place. Les sous-sections suivantes listent les séquences de solutions de repli pour chaque cas. CWD est le répertoire de travail courant, DIR est le répertoire spécifié par --directory.

  Interpréteur de commande de connexion ou commande
Transition
(Hôte → Chroot) | Commentaire
CWD → passwd pw_dir | Comportement normal (si --directory n'est pas utilisé)
CWD → / | Si passwd pw_dir n'existe pas
FAIL | Si / n'existe pas

  utilisation de --directory
Transition
(Hôte → Chroot) | Commentaire
CWD → DIR | Comportement normal
FAIL | Si CWD n'existe pas

Aucune solution de repli ne devrait exister en toute circonstance.

  Débogage

Notez que --debug=notice affichera la liste interne des répertoires de repli calculée pour la session.

EXEMPLES
    $ dchroot-dsa -l↵
    Available chroots: sarge, sid
    $ dchroot-dsa --listpaths↵
    /srv/chroot/sarge
    /srv/chroot/sid
    $ dchroot-dsa -q sid -- /bin/uname↵
    Linux
    $ dchroot-dsa sid↵
    I: [sid chroot] Running login shell: “/bin/bash”
    $

Notez que la première ligne a été affichée sur l'erreur standard, et le reste sur la sortie standard. C'est intentionnel, pour que la sortie du programme exécuté dans le chroot puisse être redirigée à l'aide d'un pipe si besoin ; les données seront les mêmes que si la commande était exécutée directement sur le système hôte.

DÉPANNAGES
Si quelque chose ne fonctionne pas, et qu'il n'est pas facile de déterminer ce qui ne va pas à partir des messages d'erreur, vous pouvez utiliser l'option --debug=niveau pour activer les messages de débogage. Cela donnera un plus grand nombre d'informations. Les niveaux de débogage valables sont ‘none’, ‘notice’, ‘info’, ‘warning’ et ‘critical’ par ordre croissant de sévérité. Plus le niveau de sévérité est faible, plus il y a de sortie.

Si vous avez toujours des problèmes, les développeurs peuvent être contactés sur la liste de diffusion (en anglais) :
Debian buildd-tools Developers
<buildd-tools-devel@lists.alioth.debian.org>

BOGUES
Sur les architectures mips et mipsel, les noyaux Linux, jusqu'à la version 2.6.17 incluse, ont une prise en charge cassée des personality(2), qui a pour conséquence un échec de la mise en place des personnalités. Cela se manifeste par une erreur “Operation not permitted” (EPERM). Pour contourner ce problème, définissez personality à ‘undefined’ ou mettez à niveau votre noyau vers une version plus récente.

FICHIERS

/etc/schroot/schroot.conf
    Le fichier de configuration de schroot pour l'ensemble du système. Ce fichier doit être possédé par l'utilisateur root, et être non inscriptible par les autres.

AUTEURS
Roger Leigh.

Cette implémentation de dchroot-dsa utilise les même options de ligne de commande que le dchroot trouvé sur les machines exécutées par les Administrateur Système Debian pour le projet Debian. Ces machines ont un paquet source dchroot-dsa qui fournit un paquet dchroot-dsa, écrit par Ben Collins <bcollins@debian.org> et Martin Schulze <joey@debian.org>.

COPYRIGHT
Copyright © 2005-2012 Roger Leigh <rleigh@debian.org>

dchroot-dsa est un logiciel libre : vous pouvez le redistribuer et/ou le modifier aux conditions définies dans la licence publique générale GNU telle que publiée par la Free Software Foundation, version 2 ou, selon votre préférence, toute version ultérieure.

VOIR AUSSI
schroot(1), sbuild(1), chroot(2), schroot-setup(5), schroot.conf(5).